﻿using System.Data.OleDb;

using DevExpress.Data.PivotGrid;
using DevExpress.XtraEditors;
using DevExpress.XtraPivotGrid;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 연결
        /// </summary>
        private OleDbConnection connection;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.connection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=nwind.mdb");

            this.pivotGridControl.OptionsView.RowTotalsLocation = PivotRowTotalsLocation.Tree;

            this.pivotGridControl.DataSource = Order.GetOrderList(this.connection);

            this.pivotGridControl.RetrieveFields();

            PivotGridField orderIDField     = this.pivotGridControl.Fields["OrderID"    ];
            PivotGridField orderDateField   = this.pivotGridControl.Fields["OrderDate"  ];
            PivotGridField shipCountryField = this.pivotGridControl.Fields["ShipCountry"];
            PivotGridField shipCityField    = this.pivotGridControl.Fields["ShipCity"   ];

            shipCountryField.Area = PivotArea.RowArea;

            shipCityField.Area = PivotArea.RowArea;

            orderDateField.Area          = PivotArea.ColumnArea;
            orderDateField.GroupInterval = PivotGroupInterval.DateMonthYear;

            orderIDField.Area        = PivotArea.DataArea;
            orderIDField.SummaryType = PivotSummaryType.Count;

            this.pivotGridControl.ShowingEditor += pivotGridControl_ShowingEditor;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 피벗 그리드 컨트롤 에디터 표시시 처리하기 - pivotGridControl_ShowingEditor(sender, e)

        /// <summary>
        /// 피벗 그리드 컨트롤 에디터 표시시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void pivotGridControl_ShowingEditor(object sender, CancelPivotCellEditEventArgs e)
        {
            if(e.RowValueType != PivotGridValueType.Value || e.ColumnValueType != PivotGridValueType.Value)
            {
                e.Cancel = true;
            }
        }

        #endregion
    }
}